<?php /* _\|/_
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso-Module "Guestbook"                                           |
+------------------------------------------------------------------------+
| Copyright (c) Matthias Vorwergk                                        |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso.de                                             |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Mattias Vorwergk <matthias.vorwergk@web.de>                   |
+------------------------------------------------------------------------+
*/

if (!defined('CPO')) exit;

//Das folgende wird normalerweise in abgewandelter Form in _include/common.inc.php gesetzt.
//TODO Dies muss bei nderungen in der common.inc.php entsprechend verndert werden
$tagsPreg  = '/<!--\s*(gb_text|gb_url|guestbook|file|html|image|text|url|value)\s*:\s*([^;]*?)\s*(;\s*(.*?)\s*)?-->/si'; //FIXME: Balu replace this with the stuff in $hdl_parser_*
$typeNames = array('', 'file', 'html', 'image', 'text', 'url', 'value');

global $cpoSystem;


$db = new DB;

switch ($install_action) {

//Modul-Installation
case 'install':

    //Start Template erstellen
    $template_name = __('Guestbook').' ('.$moduleDirectory.')';
    $guestbook_template_first = '<!--Gstebuch Eintrge anzeigen-->
        
        <table border="1">
        <tr><td colspan="2">
        <a name="<!-- Value: articlenr -->"></a>
        <!-- ifSet: link2comment; --><!-- guestbook: link2comment; label=[Eintrag kommentieren]; --><!-- /ifSet -->
        <!-- ifSet: link2quote; --> <!-- guestbook: link2quote; label=[Eintrag zitieren]; --><!-- /ifSet -->
        <!-- ifSet: link2edit; --> <!-- guestbook: link2edit; label=[Editieren];--><!-- /ifSet -->
        </td></tr>
        <tr><td>Datum:</td><td><!-- Value: pub_date; --></td></tr>
        <tr><td>Name:</td><td><!-- Value: Author; name; --></td></tr>
        <!-- ifSet: authoremail; --><tr><td>E-Mail:</td><td>
        <a href="<!-- Value: author_mod_contact; email; --><!-- ifNotSet: author_mod_contact; -->mailto:<!-- Value: Author; email_encode; --><!-- /ifNotSet -->"><!-- Value: Author; email_antispam; --></a>
        </td></tr><!-- /ifSet -->
        <!-- ifSet: Homepage; --> <tr><td>Homepage:</td><td><!-- url: Homepage; --></td></tr><!-- /ifSet -->
        <tr><td>Titel:</td><td><!-- Value: Title; --></td></tr>
        <tr><td>Besuch:</td><td><!-- Text: Besuch; --></td></tr>
        <tr><td>Nachricht:</td><td><div class="abbc"><!-- Text: Nachricht; nl2br; strip_tags; abbc;--></div></td></tr>
        <!-- ifSet: comments; --><tr><td>Kommentare:</td><td> <!-- guestbook: comments;--></td></tr><!-- /ifSet -->
        <!-- ifSet: fastedit; --><tr><td colspan="2">Eintrag nochmal <!-- guestbook: fastedit; label=bearbeiten; --></td></tr><!-- /ifSet -->
        </table>
        <!-- ifSet: link2gb; --><br /><!-- guestbook: link2gb; starttag; -->zurck zum Gstebuch</a><!-- /ifSet -->';
    $guestbook_template_detail = '<!-- Gstebuch Eintrag hinzufgen -->
        
        <h2><!-- ifSet: link2enter; -->Ins Gstebuch eintragen<!-- /ifSet -->
        <!-- ifSet: link2comment; -->Eintrag: "<!-- Value: Title -->" kommentieren<!-- /ifSet -->
        <!-- ifSet: link2edit; -->Eintrag: "<!-- Value: Title -->" bearbeiten<!-- /ifSet -->
        <!-- ifSet: fastedit; -->Eintrag: "<!-- Value: Title -->" nocheinmal bearbeiten<!-- /ifSet --></h2>
        
        <table border="1">
        <tr><td>Name:</td><td><!-- gb_text: Author; needed; --></td></tr>
        <tr><td>E-Mail:</td><td><!-- gb_text: Email; needed; mailcheck=Dies scheint keine korrekte E-Mail zu sein.;--></td></tr>
        <tr><td>Homepage:</td><td><!-- gb_url: Homepage; --></td></tr>
        <tr><td>Titel:</td><td><!-- gb_text: Title; needed=Bitte trage doch einen Titel bzw. ein Betreff ein!; --></td></tr>
        <tr><td>Besuch:</td><td>
        <!-- gb_text: Besuch; type=radio; needed=Bitte whlen Sie bei "Besuch", wie oft Sie schon auf unserer Seite waren!; value=zum ersten Mal; label=Ich bin zum ersten mal hier zu Besuch.; --><br />
        <!-- gb_text: Besuch; type=radio; needed; value=war schonmal da; label=Ich war schonmal auf dieser Seite.; --><br />
        <!-- gb_text: Besuch; type=radio; needed; value=regelmig; label=Ich bin regelmig auf dieser Seite.-->
        </td></tr>
        <tr><td colspan="2"><b>Nachricht:</b><br />
        <!-- gb_text: Nachricht; needed; badwords=kleingro; abbc="Einfache Schriftformatierung:",b,u,i,s,o,m,sup,sub,<br>,"Hyperlinks & Listen: ",url,mail,img,list,listp,<br>,"Andere: ",br,line,#,quote,code,<br>,"Weitere Formatierungen einblenden:",smilies,color,size,<br>,font,mark;-->
        </td></tr>
        <!-- ifSet: captcha; --><tr><td>Prfcode:</td><td><!-- guestbook: captcha; type=image; image; message=Trage bitte den Prfcode aus der Grafik ins Textfeld daneben ein!; --><!-- guestbook: captcha; input; --><br /> Trage bitte den Prfcode aus der Grafik ins Textfeld ein.</td></tr><!-- /ifSet -->
        <tr><td colspan="2"><!-- guestbook: submit; label=Senden;--> <!-- guestbook: reset; label=Zurcksetzen; --></td></tr>
        </table>
        
        <!-- ifSet: link2gb; --><!-- guestbook: link2gb; starttag; -->zurck zum Gstebuch</a><!-- /ifSet -->';
    $guestbook_template_javascript = '<!--Gstebuch Kommentar-Eintrge anzeigen-->
        
        <p>
        <a name="<!-- Value: articlenr -->"></a>
        <!-- ifSet: authoremail; --><!-- Value: Author; email_js_starttag;--><!-- /ifSet --><!-- Value: Author; name; --><!-- ifSet: authoremail; --></a><!-- /ifSet -->
        <!-- ifSet: Homepage; --> (<!-- url: Homepage; -->)<!-- /ifSet --> schrieb am <!-- Value: pub_date; format=l \d\e\m d.m.Y H:i \U\h\r; --><br />
        <strong><!-- Value: Title; --></strong>
        <div class="abbc"><!-- text: Nachricht; nl2br; strip_tags; abbc; --></div>
        <!-- ifSet: link2edit; --><!-- guestbook: link2edit; label=edit; --><!-- /ifSet -->
        <!-- ifSet: link2quote; --> <!-- guestbook: link2quote; label=zitat; --><!-- /ifSet -->
        </p>';
    $guestbook_template_date = date('Y-m-d H:i:s');
    $query_add_template = "INSERT INTO ".CPO_TEMPLATES." (id, name, tpl_first, tpl_detail, tpl_javascript, c_time, changer) "
        ."VALUES ('', '".addslashes($template_name)."', '".addslashes($guestbook_template_first)."', '".addslashes($guestbook_template_detail)."', '".addslashes($guestbook_template_javascript)."', '".addslashes($guestbook_template_date)."', 'Setup: Modul Guestbook');";

    //Ist Template mit diesem Namen schon vorhanden?
    $query = "SELECT id FROM ".CPO_TEMPLATES." WHERE name='".addslashes($template_name)."' ";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query); 
    if ($db->num_rows()>0) {
        //Template-ID ermitteln
        $db->next_record();
        $template_id = $db->v('id');
        
        if($template_id!='')
            $GLOBALS['message'][] = sprintf(___('Template %s was already present.'), '<em>'.$template_name.'</em>');
    } else {
        //Template anlegen
        DEBUG(1, $query_add_template, __FILE__, __LINE__);   
        $db->query($query_add_template);
        //Template-ID ermitteln
        $query_get_template_id = "SELECT id FROM ".CPO_TEMPLATES." WHERE name = '".addslashes($template_name)."' AND c_time ='".addslashes($guestbook_template_date)."'";
        DEBUG(1, $query_get_template_id, __FILE__, __LINE__);   
        $db->query($query_get_template_id);
        $db->next_record();
        $template_id = $db->v('id');

        if($template_id!='')
            $GLOBALS['message'][] = sprintf(___('Template %s was created successfully.'), '<em>'.$template_name.'</em>');
    }
    
    //Platzhaltereinstellungen setzen bzw. aktualisieren
    
    // create a list of all placeholders in this template and add a positional counter for each.
    $guestbook_template_datei_full = $guestbook_template_first."\n".$guestbook_template_detail."\n".$guestbook_template_javascript;

    // find all used Fields used in the templates
    preg_match_all($tagsPreg, $guestbook_template_datei_full, $matches, PREG_SET_ORDER);
    $placeholder = array();
    foreach ($matches as $match) {
        $_type = strtolower(trim($match[1]));
        $_name = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[2]));

        // skip Value, Guestbook, ifSet, ifNotSet, because those don't have "input settings"
        if ($_type=='value') continue;
        if ($_type=='guestbook') continue;
        // rename gb_Text to Text and gb_URL to URL, and continue, if the placeholders have special names
        if ($_type=='gb_text') {
            if (strtolower($_name)=='author' || strtolower($_name)=='email' || strtolower($_name)=='title') {
                continue;
            } else {
                $_type = 'text';
            }
        }
        if ($_type=='gb_url') $_type = 'url';

        $pos = $_name.' ('.$_type.')';
        $placeholder[$pos]['type'] = $_type;
        $placeholder[$pos]['name'] = $_name;
    }

    // fetch old positions and data
    $q = "SELECT ttype, fieldname, pos, ddata "
        ."FROM ".CPO_PLACEHOLDERS." "
        ."WHERE templates_id='".addslashes($template_id)."' ";
    $dbq = new DB;
    DEBUG(1, $q, __FILE__, __LINE__);
    $dbq->query($q);

    while($dbq->next_record()) {
        $phname = $dbq->v('fieldname').' ('.$typeNames[$dbq->v('ttype')].')';

        // if the placeholder does not exist in the template, don't use its settings
        if (!array_key_exists($phname, $placeholder)) continue;

        $placeholder[$phname]['pos'] = $dbq->v('pos');
        $placeholder[$phname]['data'] = $dbq->v('ddata');
    }

    // sort array by pos / Name
    $_pos = array();
    foreach ($placeholder as $k=>$v) {
        if (isset($v['pos'])) $_pos[$k] = $v['pos'];
        else                  $_pos[$k] = strtolower($k);
    }
    array_multisort($_pos, SORT_ASC, $placeholder);

    // delete all old settings and positions
    $q = "DELETE FROM ".CPO_PLACEHOLDERS." "
        ."WHERE templates_id='".addslashes($template_id)."' ";
    $dbq = new DB;
    DEBUG(1, $q, __FILE__, __LINE__);
    $dbq->query($q);

    // add a positional counter to all elements and store them in the database
    $pos = 1;
    foreach ($placeholder as $k=>$v) {
        $placeholder[$k]['pos'] = $pos++;

        $q = "INSERT INTO ".CPO_PLACEHOLDERS." "
            ."(templates_id, ttype, fieldname, pos, ddata) VALUES ("
            ."'".addslashes($template_id)."', "
            ."'".addslashes(array_search($placeholder[$k]['type'], $typeNames))."', " 
            ."'".addslashes($placeholder[$k]['name'])."', "
            ."'".addslashes($placeholder[$k]['pos'])."', "
            ."'".addslashes($placeholder[$k]['data'])."' "
            .")";
        $dbq = new DB;
        DEBUG(1, $q, __FILE__, __LINE__);
        $dbq->query($q);
    }
    //Ende Template erstellen
    
    //Start Rubrik erstellen
    $query = "SELECT COUNT(*) FROM ".CPO_RUBRIC." WHERE directory='".addslashes($moduleDirectory)."' ";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query);
    $db->next_record();
    
    if ($db->v('COUNT(*)')==0) {
        $rubric_name = __('Guestbook')." (".$moduleDirectory.")";
        $query_add_rubric = "INSERT INTO ".CPO_RUBRIC." (directory, name, seclevel, source_rubric_id, settings) "
            ." VALUES ("
            ."'".addslashes($moduleDirectory)."', " //directory
            ."'".addslashes($rubric_name)."', " //name
            ."'0', " //seclevel
            ."'0', " //source_rubric_id
            ."'".serialize(array('title'=>__('Guestbook'), 'disableRubricText'=>'', 'noArticlesFound'=>__('No articles found.'),  'noOfArticles'=>'10', 'sorting'=>'idx desc, pub_datum desc', 'edit_index'=>'1', 'edit_author'=>'1', 'edit_initial'=>'1', 'edit_email'=>'1', 'standard_template'=>$template_id, 'language'=>__('english'), 'date_format'=>'', 'articleSeparator'=>'', 'pager_previous'=>'', 'pager_next'=>'', 'pager_found'=>'', 'pager_results'=>'', 'showArchiveText'=>'Archiv'))."' " //settings
            .");";
        DEBUG(1, $query_add_rubric, __FILE__, __LINE__);   
        $db->query($query_add_rubric);
        
        //Rubrik-ID auslesen
        $query = "SELECT last_insert_id()";
        $db->query($query);
        $db->next_record();
        $rubric_id = $db->v('last_insert_id()');
        
        // allow the creating user to access the rubric
        $sql = "INSERT INTO ".CPO_PERMISSION." "
              ."(rubric_id, user_id, stufe1, stufe2, stufe3, stufe4) "
              ."VALUES ( "
              ."'".addslashes($rubric_id)."', " // rubric_id
              ."'".addslashes($_SESSION['SID_user']['id'])."', " // user_id
              ."'1', " // stufe1 
              ."'1', " // stufe2
              ."'1', " // stufe3
              ."'1' )"; // stufe4
        $db->query($sql);
        
        // update template assignments
        $sql = "DELETE FROM ".CPO_TPL_ASSIGNMENT." "
             . "WHERE rubric_id='".addslashes($rubric_id)."'";
        DEBUG(1, 'Deleting template assignments for this rubric.<br /><br />'.$sql, __FILE__, __LINE__);
        $db->query($sql);
        
        // set the standard_template als Template fr this Rubric
        $sql = "INSERT INTO ".CPO_TPL_ASSIGNMENT." "
            ."( rubric_id, templates_id, c_time, changer) VALUES ("
            ."'".addslashes($rubric_id)."', "
            ."'".addslashes($template_id)."', "
            ."'".date("Y-m-d H:i:s",time())."', "
            ."'Setup: Modul Guestbook') ";
        DEBUG(1, 'Inserting tpl assignement.<br /><br />'.$sql, __FILE__, __LINE__);
        $db->query($sql);

        
        $GLOBALS['message'][] = sprintf(___('Rubric %s with the Nr. %s was created successfully.'), '<em>'.$rubric_name.'</em>', '<em>'.$rubric_id.'</em>');
    }
    //Ende Rubrik erstellen
    
    //Moduleinstellungen setzen
    $temp_options = array(
        //license
        'owner'=>(!empty($cpoSystem['owner']) ? $cpoSystem['owner'] : ''),
        'lkey'=>'',
        //Guestbook settings
        'template_id'=>$template_id,
        'setup_template_id'=>$template_id, //Beim Setup zugewiesene Template-ID
        'gb_user_id'=>'1',
        'save_hostaddress'=>'1',
        'use_userdata'=>'1',
        'use_userid'=>'1',
        'language'=>__('english'),
        'date_format'=>'l, d.m.Y H:i \U\h\r',
        'send_email'=>'0',
        'email'=>(!empty($cpoSystem['admin_email']) ? $cpoSystem['admin_email'] : 'name@domain.ltd'),        
        'email_subject'=>__('New/Edited guestbook-article'),
        'template_mail'=>'------------------------------------------------------------------------
Diese E-Mail wurde automatisch generiert.
Sollten Sie eine Frage haben, kontaktieren Sie bitte Ihren Administrator: <!-- value: cpoSystem; admin_email; -->.
------------------------------------------------------------------------
Es gibt einen neuen/bearbeiteten Artikel in der Gstebuch-Rubrik "<!-- value: rubric; name; -->" des Projekts: "<!-- value: cpoSystem; project; -->" unter "<!-- value: cpoSystem; base_url; -->"

Datum: <!-- value: pub_date; format=l, d.m.Y H:i \U\h\r; -->

<!-- guestbook: form_data; before=- ; between=:&nbsp; after=<br/>; -->',
        //Settings for the form-page ('detail.php')
        'saved_message'=>__('Your guestbook-entry is saved! Thank You!'),
        'releaseNewArticles'=>'1',
        'notReleased_message'=>__('Your entry will be released later, please be patient.'),
        'nextview_after_entry'=>'confirm',
        'everybody_can_enter'=>'1',//FIXME dies kann ich noch nach Benutzergruppen genauer unterscheiden
        'everybody_can_comment'=>'1',
        'badwords'=>__('list_of_badwords_(parted_by_space)'),
        'badwords_replace'=>'*****',
        'releaseBadwordArticles'=>'1',
        'notReleased_badwordMessage'=>__('Your entry will be released later, please be patient.'),       
        'textarea_rows'=>'10',
        'textarea_cols'=>'50',
        //Settings for the rubric-pae 'index.php')
        'index_view'=>'index',
        'empty_field_message'=>__('Please write something in the %s field!'),
        'noArticlesFound'=>__('No entrys found, please enter the fist entry.'),
        'noOfArticles'=>'10',
        'sorting'=>'idx desc, pub_datum desc',
        'sorting_comment'=>'idx asc, pub_datum asc',
        'print_comments'=>'no',       
        'articleSeparator'=>'__________<br /><br />',
        'commentSeparator'=>' _ _ _ _ _<br /><br />',
        //FIXME eventuell kann hier noch eine Option hin, welche die Navigationstexte komplett ausblendet
        'pager_showresults'=>'0',
        'pager_previous'=>'',
        'pager_next'=>'',
        'pager_found'=>'',
        'pager_results'=>'',
        //Guestbook Einstellungen, die nicht abgefragt werden
        'admin'=>'3',//Superuser und Admins drfen Einstellungen bearbeiten
        'keywords'=>__('Guestbook-Article'),
        'installed'=>time()
    );        
    $GLOBALS['modules'][ucfirst($moduleDirectory)] = array_merge ($GLOBALS['modules'][ucfirst($moduleDirectory)], $temp_options);

    break;

default:

    $GLOBALS['message'][] = '<strong>'.__('Exception error!').'</strong>';
    break;

}
  
?>