<?php /* _\|/_
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso-Module "Guestbook"                                           |
+------------------------------------------------------------------------+
| Copyright (c) Matthias Vorwergk                                        |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso.de                                             |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Mattias Vorwergk <matthias.vorwergk@web.de>                   |
+------------------------------------------------------------------------+
*/

if (!defined('CPO')) exit;

global $content, $key, $parameters, $replacement;

$_t = $content[$key]['text'];
if (array_key_exists('strip_tags', $parameters)) {
    $_t = strip_tags($_t);
}

//http://community.conpresso.de/viewtopic.php?t=3054 && mod_guestbook
if (!array_key_exists('html_tags', $parameters) && !array_key_exists('abbc', $parameters)) {
   $_t = htmlspecialchars($_t);
}

if (array_key_exists('nl2br', $parameters) && !array_key_exists('abbc', $parameters)) {
    $_t = nl2br($_t);
}

//mod_guestbook
if (array_key_exists('abbc', $parameters)) {
    $_t = abbc_proc($_t);
}
$replacement = $_t;
?>
